﻿Type=StaticCode
Version=2.51
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
'Code module

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.

	Public Pnl_Segunda, Pnl_Segunda_Titulo As Panel
	Public lbl_Tela2_Titulo As Label
	Public Im_Voltar_Padrao As ImageView
	
'Multi CheckBox
	Private pnlClass As Panel
	Private CallBack As Object
	Private mEventName As String
	Private myPanel As Panel
	Private Sv_Multi As ScrollView
	Private Pnl_Multi As Panel
	Public fMulti_Select As Boolean
	Private Mp As MediaPlayer


End Sub


Sub Monta_titulo ( pPnl As Panel, pTitulo As String )
	If Main.Ini_Conf.IsInitialized = False Then 	Main.Ini_Conf.Initialize(File.DirDocuments,"Ini_LA")
	If Pnl_Segunda.IsInitialized Then
		Try
			Pnl_Segunda_Titulo.RemoveAllViews
			Pnl_Segunda_Titulo.RemoveViewFromParent
			Pnl_Segunda.RemoveAllViews
			Pnl_Segunda.RemoveViewFromParent
		Catch
			Log(LastException)
		End Try
	End If	
	lbl_Tela2_Titulo.Initialize ( "")			'origem dados GPS, NET
'	lbl_Tela2_Titulo.Gravity = Gravity.CENTER
'	lbl_Tela2_Titulo.TextColor = Main.gTextColor_Titulo 'Colors.Blue 'Colors.White
'	lbl_Tela2_Titulo.TextSize = gTextSize_Titulo
'	lbl_Tela2_Titulo.Typeface = Typeface.DEFAULT_BOLD	
	lbl_Tela2_Titulo.Multiline = True
	lbl_Tela2_Titulo.TextAlignment = lbl_Tela2_Titulo.ALIGNMENT_LEFT
	lbl_Tela2_Titulo.AdjustFontSizeToFit = True
	lbl_Tela2_Titulo.Text = pTitulo

	Pnl_Segunda.Initialize("Pnl_Segunda")
	Pnl_Segunda.Color = Main.gColor_Back
	Pnl_Segunda_Titulo.Initialize("")
	Pnl_Segunda_Titulo.Color = Main.gColor_back_Titulo 'Colors.RGB (236,253,253 ) ' (248,255,254)'(255,255,235 ) '(252,255,255) ' Colors.LightGray
	
	Im_Voltar_Padrao.Initialize ( "Im_Voltar_Padrao")
	Im_Voltar_Padrao.Bitmap =  Main.Images.Get ("voltar")
	Im_Voltar_Padrao.ContentMode = Im_Voltar_Padrao.MODE_FILL '.Gravity = Gravity.FILL
	Pnl_Segunda.AddView ( Pnl_Segunda_Titulo,0,0,Main.gWidth, 50 )
	Pnl_Segunda_Titulo.AddView ( Im_Voltar_Padrao,0, 10, 45, 35 )
	Pnl_Segunda_Titulo.AddView ( lbl_Tela2_Titulo , 60, 5, (Main.gWidth-65) , 40 )
	Main.Ini_Conf.Put ( "Volta","1" )
	
	pPnl.AddView ( Pnl_Segunda,0,0,Main.gWidth, Main.gHeight )

End Sub

'ComboSelected is called by the Class Module whenever a combo item is selected.
'You are advised to set the Tag Property of each Textfield used for Combo boxes in the designer to a unique name eg Combo1, Combo2 etc
'This tag field can then be retrieved as shown below:
Sub ComboSelected(Item As String, textbox As TextField)
	Dim clist As List, ComboName As String
	clist=textbox.Tag  		' <--------- The original tag of the textbox has been replaced by a list object
	ComboName=clist.Get(0)	' <--------- Item 0 in the list is the original tag
							' <--------- Item 1 in the associated TableView Object
							' <--------- Item 2 in the associated ImageView that holds the Down Arrow Icon
	
							
#if Log
	Log("====== " & ComboName & " Item selected '" & Item & "' =========")
#end if	
	'Just to show something has happened in this example
'	Page1.Title=Item
'	Page2.Title=Item
End Sub

'This sub is called for manual changes to the text part of the Combo box (if enabled for the TextField)
'This is part of the normal logic for TextFields
'NB ComboChange is used in this example as the EventName for all of the combo boxes
'If you want individual EndEdit Events for each combobox, then that is OK
Sub ComboChange_EndEdit
	Dim t As TextField
	t=Sender
	t.ResignFocus
	'If you used the tags in the TextFields then you can get that back as shown below
	Try
		Dim l=t.Tag As List, ComboName As String
		ComboName=l.Get(0)
#if Log
		Log ( ComboName & " End edit. Result: " & t.Text)
#end if		
	Catch
		Log(LastException)
	End Try

End Sub


Sub Im_Voltar_Padrao_Click
	Main.NavControl.RemoveCurrentPage
	Main.NavControl.ShowPage(Main.Page1)
	Main.inicial
			

End Sub

public Sub CheckConnection As Boolean
	Dim server As ServerSocket 'ignore
	
	Return server.GetMyIP <> "127.0.0.1"	
	
End Sub


Sub Return_Height ( Ppanel As Panel, pFontSize As Int , pText As String , pWidth As Int, pBold As Boolean) As Int
	Dim xHeight As Int
	Dim Lbl As Label
	Lbl.Initialize ( "")
	Lbl.Visible = False
	Ppanel.AddView(Lbl,0,0,0,0)
	Lbl.Multiline = True
	Lbl.Text = pText
	If pBold Then
		Lbl.Font = Font.CreateNewBold(pFontSize)
	Else	
		Lbl.Font = Font.CreateNew(pFontSize)
	End If
	Lbl.Width = pWidth
	Lbl.SizeToFit
	xHeight =  Lbl.Height
	Lbl.RemoveViewFromParent
	Return  xHeight
End Sub

Sub Linkify(tv As TextView)
   Dim no As NativeObject = tv
   no.SetField("editable", False)
   no.SetField("dataDetectorTypes", 0xffffffff)
End Sub

Sub GetVersion As String
   Dim no As NativeObject
   no = no.Initialize("NSBundle").RunMethod("mainBundle", Null)
   Dim name As Object = no.RunMethod("objectForInfoDictionaryKey:", Array("CFBundleShortVersionString"))
   Return name
End Sub

Sub GetDeviceModel As String
    ' get the device model
    Dim device As NativeObject
    device = device.Initialize("UIDevice").RunMethod("currentDevice", Null)
    Dim name As Object = device.GetField("model").AsString
    Return name
End Sub

'pTipo = 1 embaralha  e pTipo = 0 desembaralha
Sub embaralha ( pTipo As String, pDados As String )
	Dim xLen As Int
	Dim xResp As String
	xLen = pDados.Length
	If pTipo = 1 Then
		Select xLen
		Case 6
			xResp = Chr( Asc(pDados.SubString2(1,2)) + 5 + 14 ) 
			xResp = xResp & Chr( Asc(pDados.SubString2(5,6)) + 5 + 6 )
			xResp = xResp & Chr( Asc(pDados.SubString2(4,5)) + 5 + 10 )
			xResp = xResp & Chr( Asc(pDados.SubString2(0,1)) + 5 + 13 )
			xResp = xResp & Chr( Asc(pDados.SubString2(2,3)) + 5 + 4 )
			xResp = xResp & Chr( Asc(pDados.SubString2(3,4)) + 5 + 7 )
		Case 7
			xResp = Chr( Asc(pDados.SubString2(3,5)) + 5 + 11 )
			xResp = xResp & Chr( Asc(pDados.SubString2(4,5)) + 5 + 13 )
			xResp = xResp & Chr( Asc(pDados.SubString2(0,1)) + 5 + 1 )
			xResp = xResp & Chr( Asc(pDados.SubString2(5,6)) + 5 + 15 )
			xResp = xResp & Chr( Asc(pDados.SubString2(6,7)) + 5 + 16 )
			xResp = xResp & Chr( Asc(pDados.SubString2(1,2)) + 5 + 7 )
			xResp = xResp & Chr( Asc(pDados.SubString2(2,3)) + 5 + 5 )
		Case 8
			xResp = Chr( Asc(pDados.SubString2(2,3)) + 5 + 8 )
			xResp = xResp & Chr( Asc(pDados.SubString2(6,7)) + 5 + 7 )
			xResp = xResp & Chr( Asc(pDados.SubString2(1,2)) + 5 + 15 )
			xResp = xResp & Chr( Asc(pDados.SubString2(5,6)) + 5 + 12 )
			xResp = xResp & Chr( Asc(pDados.SubString2(4,5)) + 5 + 5 )
			xResp = xResp & Chr( Asc(pDados.SubString2(0,1)) + 5 + 16 )
			xResp = xResp & Chr( Asc(pDados.SubString2(7,8)) + 5 + 3 )
			xResp = xResp & Chr( Asc(pDados.SubString2(3,4)) + 5 + 10 )
	
		End Select
	End If
	If pTipo = 0 Then
		Select xLen
		Case 6
			xResp = Chr( Asc(pDados.SubString2(3,4)) - 5 - 13 )
			xResp = xResp & Chr( Asc(pDados.SubString2(0,1)) - 5 - 14 )
			xResp = xResp & Chr( Asc(pDados.SubString2(4,5)) - 5 - 4 )
			xResp = xResp & Chr( Asc(pDados.SubString2(5,6)) - 5 - 7 )
			xResp = xResp & Chr( Asc(pDados.SubString2(2,3)) - 5 - 10 )
			xResp = xResp & Chr( Asc(pDados.SubString2(1,2)) - 5 - 6 )
		Case 7
			xResp = Chr( Asc(pDados.SubString2(2,3)) - 5 - 1 )
			xResp = xResp & Chr( Asc(pDados.SubString2(5,6)) - 5 - 7 )
			xResp = xResp & Chr( Asc(pDados.SubString2(6,7)) - 5 - 5 )
			xResp = xResp & Chr( Asc(pDados.SubString2(0,1)) - 5 - 11 )
			xResp = xResp & Chr( Asc(pDados.SubString2(1,2)) - 5 - 13 )
			xResp = xResp & Chr( Asc(pDados.SubString2(3,4)) - 5 - 15 )
			xResp = xResp & Chr( Asc(pDados.SubString2(4,5)) - 5 - 16 )
		Case 8
			xResp = Chr( Asc(pDados.SubString2(5,6)) - 5 - 16 )
			xResp = xResp & Chr( Asc(pDados.SubString2(2,3)) - 5 - 15 )
			xResp = xResp & Chr( Asc(pDados.SubString2(0,1)) - 5 - 8 )
			xResp = xResp & Chr( Asc(pDados.SubString2(7,8)) - 5 - 10 )
			xResp = xResp & Chr( Asc(pDados.SubString2(4,5)) - 5 - 5 )
			xResp = xResp & Chr( Asc(pDados.SubString2(3,4)) - 5 - 12 )
			xResp = xResp & Chr( Asc(pDados.SubString2(1,2)) - 5 - 7 )
			xResp = xResp & Chr( Asc(pDados.SubString2(6,7)) - 5 - 3 )
		
		End Select
	End If
	
	Return xResp


End Sub

Sub Cripto ( pTipo As String, pQtd As String, pTexto As String) As String
	Dim xOff As Int
	Dim xTemp, xResp  As String	
	Dim xBytes() As Byte
	Dim bConv As ByteConverter
	
	Select pQtd
		Case "25"
			If pTipo = 1 Then 
				xTemp = bConv.HexFromBytes ( pTexto.GetBytes("UTF8") )
				xTemp = str_pad ( xTemp, " ", 50, False )     '    Sf.Pad ( xTemp," ",50,True)
			Else
				xTemp = pTexto	
			End If
			xOff = 0
			xResp =          embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8

			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+7) ) 
			xOff = xOff + 7
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+7) ) 
			xOff = xOff + 7

			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+6) ) 
			xOff = xOff + 6
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+6) ) 

			If pTipo = 0 Then
				xBytes = bConv.HexToBytes ( xResp)
				xResp  = bConv.StringFromBytes (xBytes, "ASCII")
				xResp = xResp.Trim
#if log
				Log ( "Volta cripto: " & xResp )
#end if				
			End If
			
		Case "90"
			xTemp = str_pad ( xTemp, " ", 90, False ) ' Sf.Pad ( xTemp," ",90,True)
			xOff = 0
			xResp =  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+8) ) 
			xOff = xOff + 8
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+6) ) 
			xOff = xOff + 6
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+6) ) 
			xOff = xOff + 6
			xResp = xResp &  embaralha(pTipo,xTemp.SubString2(xOff, xOff+6) ) 

	End Select
#if log
Log ( "Embaralha: " & pTipo & " - " & pQtd & " - " & xTemp & " -  " & xResp )	
#end if
	Return xResp
End Sub


'PString is the original string
'pFill the character to fill the extra bytes
'pSize is the final size of the string ( if the original is bigger return the originaç
'pLeft is true if to fill at the left of the string
Sub str_pad ( pString As String, pFill As String, pSize As Int, pLeft As Boolean ) As String
	Dim xResp, xtemp As String
	Dim  xMax As Int
	If pString.Length >= pSize Then
		Return pString
	End If
	xMax = pSize - pString.Length
	xtemp = ""
	For i=0 To xMax-1
		xtemp = xtemp & pFill	
	Next
	If pLeft Then
		xResp = xtemp & pString
	Else
		xResp = pString & xtemp		
	End If

Log ( "String Ori: " & pString )
Log ( "String Final: " & xResp & "xx")

	Return xResp

End Sub

Sub beep ( pOk As Boolean ) 
	If pOk Then
	  	Mp.Initialize(File.DirAssets, "ok.mp3", "mp")
	Else	
	  	Mp.Initialize(File.DirAssets, "erro.mp3", "mp")
	End If
	Mp.Play
	
	

End Sub